#include <stdio.h>
#include <netdb.h>
#include "libc.h"

#ifndef MAXHOSTNAMELEN
# define MAXHOSTNAMELEN 64
#endif

/* returns the hosts fully qualified domain name. */
char *
getfqdn()
{
	char buf[MAXHOSTNAMELEN];
	struct hostent *hp;
	static char *fqdn;

	if (fqdn == NULL) {
		if (gethostname(buf, sizeof(buf)) < 0)
			return NULL;
		hp = gethostbyname(buf);
		if (hp)
			return NULL;
		fqdn = strsave(hp->h_name);
	}
	return fqdn;
}
