#ifndef LIBC_H_
#define LIBC_H_

#ifdef NO_VOIDSTAR
typedef char * univptr_t;
#else
typedef void * univptr_t;
#endif

#ifdef NO_STRING_H
# include <strings.h>
# define strchr(s, c)	index((s), (c))
# define strrchr(s, c)	rindex((s), (c))
#else
# include <string.h>
#endif

/* STREQ is an optimised strcmp(a,b)==0 */
#define STREQ(a, b) ((a)[0] == (b)[0] && strcmp(a, b) == 0)

#ifdef NO_STDLIB
extern univptr_t memcpy(), memmove(), malloc();
extern int errno;
extern char *getwd(), *getpass();
extern time_t time();
extern long atol();
#else
# include <stdlib.h>
#endif
#include <time.h>
extern int lstat(), stat(), chdir();

/* for getopt */
extern int optind;
extern char *optarg;


/* local routines, not in libc but generally useful */
extern univptr_t emalloc();
extern char *strsave();
extern void error(), warning();

#ifdef __svr4__
# include <sys/systeminfo.h>
# define gethostname(host, len) sysinfo(SI_HOSTNAME, (host), (len))
#endif
#endif /* LIBC_H_ */ /* Do not add anything after this line */
