/*
 * lockdebug with a non-NULL argument prints verbose tracing information
 * to the argument (must be an open stdio file pointer) A NULL argument
 * turns off tracing.
 */
extern void lockdebug(/* FILE *fp */);

/*
 * creates a lock.  The directory with the lock must be writable.  If it
 * fails, it will retry lockretries times, sleeping i seconds in between
 * reach retry.  It returns 0 if it locked successfully, -1 if it failed
 * to lock.  The lockfile will contain a line of the form "hostname pid"
 * where pid is the process id of the locking process and hostname is
 * the machine it is running on.
 */
extern int lockcreate(/* char *lockname, int lockretries, unsigned i */);

/*
 * removes a lock if it exists.  It just blasts the lockfile -- perhaps
 * it should verify that we really own the lock?
 */
extern void lockfree(/* char *lockname */);
