#include <sys/types.h>
#include <sys/file.h>
#include <fcntl.h>
#include <errno.h>
#include "libc.h"

#ifdef O_EXCL
# define OFLAGS (O_CREAT | O_WRONLY | O_EXCL)
#else
# define OFLAGS (O_CREAT | O_WRONLY)
#endif

int
opentmp(s)
char *s;
{
	int fd;
	char *fname = strsave(s);
	
	do {
		(void) strcpy(s, fname);
		(void) mktemp(s);
		fd = open(s, OFLAGS, 0777);
		if (fd < 0 && errno != EEXIST) {
			free(fname);
			return fd;
		}
	} while(fd < 0);
	free(fname);
	return fd;
}

#ifdef TEST_OPENTMP
static char mm[] = "/tmp/m/#XXXXXX";

int
main()
{
	int fd;
	time_t tloc;
	char *s;
	
	fd = opentmp(mm);
	time(&tloc);
	s = ctime((long *) &tloc);
	if (write(fd, s, strlen(s)) != strlen(s))
		perror("write");
	write(2, s, strlen(s));
	return 0;
}
#endif
