%{
# include "track.h"
extern FILE *yyin, *yyout;
char linebuf[LINELEN];
char *wordbuf[WORDMAX];
int wordcnt = 0;
%}
%token WHITESPACE COLON BACKSLASH NEWLINE BACKNEW BANG WORD GEXCEPT
%%
sublist	: header entrylist opt_space 
	;
header	: 
		{
			clear_ent();
		}
	|   GEXCEPT
		{
			strcat(g_except," ");		/* XXX */
			strcat(g_except,linebuf);	/* XXX */
			doreset();
			clear_ent();
		}
        ;
entrylist :
	  |	entrylist entry
	  ;
entry	: linkmark fromname COLON cmpname COLON toname COLON except COLON shellcmd
		{
			entrycnt++;
			if (entrycnt >= ENTRYMAX) {
				fprintf(stderr,
	"track: Exceeded the maximum for slists -- ENTRYMAX is %d\n",ENTRYMAX);
				exit(1);
			}
			clear_ent();
		}
	;
linkmark  :  opt_space
	  |  opt_space BANG opt_space
		{
			entries[entrycnt].followlink = 1;
		}
	  ;
fromname: WORD opt_space
		{
			entries[entrycnt].fromfile = wordbuf[0];
			entries[entrycnt].fromlen = strlen(wordbuf[0]);
			doreset();
		}
	;
cmpname :	
		{
			if (entries[entrycnt].followlink &&
			    gettype_stat(entries[entrycnt].fromfile,
					 (struct stat *) 0) == 'l' ) {
				entries[entrycnt].cmpfile = strsave(
					resolve(entries[entrycnt].fromfile));
				entries[entrycnt].cmplen =
					strlen(entries[entrycnt].cmpfile);
			} else {
				entries[entrycnt].cmpfile = NULL;
				entries[entrycnt].cmplen = 0;
			}
			doreset();
		}
	| opt_word
		{
			entries[entrycnt].cmpfile = wordbuf[0];
			entries[entrycnt].cmplen = strlen(wordbuf[0]);
			doreset();
		}
	;
toname  :
		{
			if (entries[entrycnt].followlink &&
			    gettype_stat(entries[entrycnt].fromfile,
					 (struct stat *) 0) == 'l' ) {
				char *cp = resolve(entries[entrycnt].fromfile);
				entries[entrycnt].tofile = strsave(cp);
				entries[entrycnt].tolen = strlen(cp);
			} else {
				entries[entrycnt].tofile = NULL;
				entries[entrycnt].tolen = 0;
			}
			doreset();
		}
	| opt_word
		{
			entries[entrycnt].tofile = wordbuf[0];
			entries[entrycnt].tolen = strlen(wordbuf[0]);
			doreset();
		}
	;
except  :
		{
			doreset();
		}
	| opt_space wordlist opt_space
		{
			int i,j;
			extern regexp *regshcomp();
			
			for(i=0; entries[entrycnt].exceptions[i] != 0;i++)
				;
			for (j=0;i < WORDMAX && j<wordcnt;i++,j++) {
				entries[entrycnt].exceptions[i] = wordbuf[j];
				entries[entrycnt].re[i]= regshcomp(wordbuf[j]);
			}
				
			if (i >= WORDMAX) {
				fprintf(stderr,
    "track:  Exceeded the maximum for exceptions -- WORDMAX is %d\n", WORDMAX);
				exit(1);
			}
			doreset();
		}
	;
wordlist: WORD
	| wordlist opt_space WORD
	;
shellcmd: firstl shline NEWLINE
		{
			if (strlen(linebuf) > 1) {
				entries[entrycnt].cmdbuf = strsave(linebuf);
			} else {
				entries[entrycnt].cmdbuf = strsave("");
			}
			doreset();
		} ;
shline	: 
	| shline WORD 
	| shline COLON
	| shline BANG
	| shline BACKSLASH
	| shline WHITESPACE
	;
firstl  : 
	| firstl shline BACKNEW 
	;
opt_word: opt_space WORD opt_space
	;
opt_space:
	| opt_space opt_ele
	;
opt_ele : NEWLINE
	| WHITESPACE
	;
	
%%

yyerror(s)
char *s;
{
	fprintf(stderr,"track: parser error -- %s\n",s);
}
#include "lex.yy.c"
