/* $Id: track.h,v 1.25 91/04/23 12:10:15 root Exp $ */
#ifndef DAEMON
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <ctype.h>
#include <stdio.h>
#include "regexp.h"
#include "stash.h"

#endif

#include "libc.h"
#include <syslog.h>

#define FALSE		0
#define TRUE		1

#ifndef DEF_ROOT
# define	DEF_ROOT	"/tmp/testtrack"
#endif
#ifndef DEF_ADM
# define DEF_ADM		"root"
#endif
/*
#define DEF_EXCEPT	"#* *.CKP"
*/
#define DEF_EXCEPT	""
#define DEF_PERM	0	/* fail if not in permissions file */

/*
 * Mode bits to mask off for transmission.  We assume these are all in the
 * same place on all architectures (lower 16 bits of the st_mode word).  Any
 * architecture for which this is not true should do a translation mapping to
 * and from standard Unix conventions in copyfile.c and stamp.c, so it
 * can interoperate with standard tracks.  (AIX!)
 */
#define MODE_BITS 0xffff

/* 
 * would be nicer to change this to ' '.  Then we could have files with
 * ; in their names.  At least one such file exists -- edhelp/h; for UofT
 * ed.  But that would break compatibility and good.
 */
#define DEF_SEP_CHAR	';'
/*#define DEF_SEP_CHAR	' '*/

extern int sep_char;

/* 
 * !! The following are the size limits.  It is quite likely that track
 * will dump core if you exceed any of these limits, especially WORDLEN,
 * possibly LINELEN as well.  Many of these should be changed to use
 * dynamically allocated strings, like C News.
 */
#define BLOCKSIZE 4096	/* buffer size when transferring files */
#define LINELEN 1024	/* Used all over the place as a buffer size */
#define WORDLEN 256	/* Used for too many things, including host names */
#define WORDMAX 128	/* Max exceptions */
#define ENTRYMAX 512	/* Max entries in an slist */


#ifndef DAEMON

extern FILE *subfile;
extern char errmsg[];
extern char g_except[];
typedef struct ent {
	int followlink;
	char *fromfile;
	int fromlen;
	char *tofile;
	int tolen;
	char *cmpfile;
	int cmplen;
	char *exceptions[WORDMAX + 1];	/* NULL terminated array */
	char *cmdbuf;
	regexp *re[WORDMAX];
	Stash *stash;
} Entry ;
extern Entry entries[];
extern char *subname;
extern char *resolve();

extern char **gargv;
extern int gargc;

extern int nopull;
extern int errno;
extern int quietflag;
extern int uflag;
extern int forceflag;
extern int verboseflag;
extern int dirflag;
extern int entrycnt;
extern int cur_ent;


#define	IS_LIST		1
#define NO_LIST		0

#define VIA_RSH		0
#define VIA_TCP		1

#define TCP_TIME	 (60 * 60 * 2)	/* amount of time allowed for each
					entry via tcp  --  two hours */
#define LOCK_TIME ((long)(60 * 60 * 6))	/* amount of time to let a lockfile
						sit before trying again
						i.e.  6 hours */
extern char *rootdir;
extern char *rrootdir;
extern char myname[];
extern char *user;
extern char *librarian;
extern int via;
extern int child_id;


#define	DO_CLOBBER	1
#define NO_CLOBBER	0
extern int clobber;

extern int inpipe;
extern int outpipe;

/* parser stuff */
extern char linebuf[];
extern int wordcnt;
extern FILE *yyin,*yyout;

#endif

extern int get_head();
extern long getsize();
extern char *mycpy();
